import 'package:equatable/equatable.dart';
import 'package:flutter/foundation.dart';

import '../../core/core.dart';
import '../../models/models.dart';

class M4eGroupForm extends Equatable {
  final M4eUniqueId id;
  final String name;
  final List<GroupEntityRole> entityRoles;
  final int joined;

  const M4eGroupForm._(this.id, this.name, this.entityRoles, this.joined);

  /// [M4eGroupForm] to create m4e group
  /// User-roles is optional as group-members can be added to the group
  factory M4eGroupForm(
      {@required String name, List<GroupEntityRole> entityRoles}) {
    assert(name != null, 'M4eGroupForm [name] should not be null');
    return M4eGroupForm._(M4eUniqueId(), name, entityRoles,
        DateTime.now().toTimestampSinceEpoch());
  }

  Map<String, dynamic> toJson() {
    return {
      'name': this.name,
      'userRoles': this.entityRoles?.map((e) => e.toJson())?.toList() ?? [],
      'joined': this.joined,
    };
  }

  @override
  List<Object> get props => [name, entityRoles];

  @override
  bool get stringify => true;
}
